
; fasm example of writing Win32 GUI application

format PE GUI
entry start

macro align value { rb (value-1) - (rva $ + value-1) mod value }

include 'win32.inc'

section '.data' data readable writeable

  newhwnd dd 0				; handle of window
  hinstance dd 0			; handle of module

  msg MSG
  wc WNDCLASS

  _title db 'flat assembler Win32 application',0
  _class db 'FASMWIN32',0

  _caption db 'Win32 assembly program',0
  _message db 'Left mouse button pressed.',0

section '.code' code readable executable

  start:

	push	0
	call	[GetModuleHandle]
	mov	[hinstance],eax

	push	17			; resource id
	push	eax			; module handle
	call	[LoadIcon]
	mov	[wc.hIcon],eax

	push	IDC_ARROW
	push	0
	call	[LoadCursor]
	mov	[wc.hCursor],eax

	mov	[wc.style],CS_HREDRAW+CS_VREDRAW+CS_GLOBALCLASS
	mov	[wc.lpfnWndProc],WindowProc
	mov	[wc.cbClsExtra],0
	mov	[wc.cbWndExtra],0
	mov	eax,[hinstance]
	mov	[wc.hInstance],eax
	mov	[wc.hbrBackground],COLOR_BTNSHADOW
	mov	[wc.lpszMenuName],0
	mov	[wc.lpszClassName],_class
	push	wc
	call	[RegisterClass]

	push	0
	push	[hinstance]		; handle
	push	0			; menu
	push	0			; parent hwnd
	push	200			; height
	push	320			; width
	push	100			; y
	push	100			; x
	push	WS_DLGFRAME+WS_SYSMENU	; style
	push	_title			; title string
	push	_class			; class name
	push	0			; extra style
	call	[CreateWindowEx]
	mov	[newhwnd],eax

	push	SW_SHOWNORMAL
	push	[newhwnd]
	call	[ShowWindow]
	push	[newhwnd]
	call	[UpdateWindow]

  msg_loop:
	push	0
	push	0
	push	0
	push	msg
	call	[GetMessage]
	or	ax,ax
	jz	end_loop
	push	msg
	call	[TranslateMessage]
	push	msg
	call	[DispatchMessage]
	jmp	msg_loop

  end_loop:
	push	[msg.wParam]
	call	[ExitProcess]

include 'stdcall.inc'

proc WindowProc, hwnd,wmsg,wparam,lparam
	push	ebx esi edi		; Win32 needs it to be preserved
	cmp	[wmsg],WM_DESTROY
	je	wmdestroy
	cmp	[wmsg],WM_LBUTTONDOWN
	je	wmlbuttondown
	cmp	[wmsg],WM_RBUTTONDOWN
	je	wmrbuttondown
      defwindowproc:
	invoke	[DefWindowProc], [hwnd],[wmsg],[wparam],[lparam]
	jmp	finish
      wmdestroy:
	invoke	[PostQuitMessage], 0
	xor	eax,eax
	jmp	finish
      wmlbuttondown:
	invoke	[MessageBox], [hwnd],_message,_caption,MB_OK+MB_ICONASTERISK
	jmp	finish
      wmrbuttondown:
	invoke	[MessageBeep], MB_OK
      finish:
	pop	edi esi ebx
	return

include 'idata.inc'
include 'resource.inc'
